SpecializationUtil.registerSpecialization("fuelAdjust", "fuelAdjust", g_currentModDirectory.."fuelAdjust.lua");

FuelFunctions = {};
FuelFunctions.modDir = g_currentModDirectory;

function FuelFunctions:loadMap(name)
	if g_currentMission.extraHudMode == nil then
		g_currentMission.extraHudMode = 0;
	end;
	if self.firstRun == nil then
		self.firstRun = false;
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil and not SpecializationUtil.hasSpecialization(TrafficVehicle, v.specializations) then
				for i = 1, table.maxn(v.specializations) do
				  local vs = v.specializations[i];
				  if vs ~= nil then
					local allowInsertion3 = true;

					local v_name_string = v.name
					local point_location = string.find(v_name_string, ".", nil, true)

					if vs == SpecializationUtil.getSpecialization("motorized") then
						if point_location ~= nil then
							local ModFileName = string.sub(v_name_string, 1, point_location-1);
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.fuelAdjust", ModFileName)), v.specializations) then
								allowInsertion3 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.FuelAdjust", ModFileName)), v.specializations) then
								allowInsertion3 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.Fueladjust", ModFileName)), v.specializations) then
								allowInsertion3 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.fueladjust", ModFileName)), v.specializations) then
								allowInsertion3 = false;
							end;
						end;
						if allowInsertion3 then
							table.insert(v.specializations, SpecializationUtil.getSpecialization("fuelAdjust"));
							if g_newGUISkin then
								vs.fAOverlay = Overlay:new("fAOverlay", (FuelFunctions.modDir.."huds/fuelAdjust_hud_ngs.dds"), 0.569, 0.093, 0.192, 0.0359);
							else
								vs.fAOverlay = Overlay:new("fAOverlay", (FuelFunctions.modDir.."huds/fuelAdjust_hud.dds"), 0.569, 0.093, 0.192, 0.036);
							end;
						end;
					end;
				  end;
				end;
			end;
		end;
	end;
end;
function FuelFunctions:deleteMap()
end;
function FuelFunctions:keyEvent(unicode, sym, modifier, isDown)
end;
function FuelFunctions:mouseEvent(posX, posY, isDown, isUp, button)
end;
function FuelFunctions:update(dt)
	if InputBinding.hasEvent(InputBinding.TOGGLE_HELP_TEXT) then
		-- 0  ->  HUDs anzeigen, Menhud an
		-- 1  ->  HUDs anzeigen, Menhud aus
		-- 2  ->  HUDs ausblenden, Menhud an
		-- 3  ->  HUDs ausblenden, Menhud aus
		g_currentMission.extraHudMode = g_currentMission.extraHudMode + 1;
		if g_currentMission.extraHudMode == 4 then
			g_currentMission.extraHudMode = 0;
		end;
	end;
end;
function FuelFunctions:draw()
end;

addModEventListener(FuelFunctions);
